<template lang="pug">
b-table( :columns='columns' :data='types' :loading='pending' )
	template( v-slot:Products='{ item }' ) {{ item.Products.length }} 
	template( v-slot:buttons='{ item }' )
		b-buttons.is-justify-content-flex-end
			b-button.is-small( type="link" @click='onEdit = item' )
				span.icon.is-small
					i.fa-solid.fa-pencil
			b-button.is-small( type="danger" @click='onRemove = item' )
				span.icon.is-small
					i.fa-solid.fa-trash-can

b-modal( v-model='modal' )
	.content.has-text-centered( v-if='onRemove' )
		template( v-if='$slots.content' )
			slot( name="content" :item='onRemove' )
		template( v-else )
			p.is-size-4.has-text-weight-bold.mb-1 Удалить категорию "{{onRemove.name}}"?
			p.is-size-6.mb-0 Все дочерние категории также будут удалены 
			p.is-size-7.has-text-grey.mb-0
				span.has-text-danger *
				span товары при этом сохранятся, но не будут привязаны к какой-либо категории
	b-buttons.is-justify-content-center
		b-button( type="danger" @click='remove(onRemove.id)' ) Удалить
		b-button( type="success" @click='onRemove = null' ) Отмена

b-modal( v-model='editModal' :title='`Редактировать "${onEdit ? onEdit.name : ""}"`' medium visible )
	TypeForm( v-if='onEdit' :parent-id='parentId' :type='onEdit' @updated='handleUpdate' )
</template>

<script setup>
import { ref, watch } from "vue"
import { useTypesStore } from "@/store/types"
import { useToast } from "vue-toastification"

import { BModal } from "@/components/modal"
import { BTable } from "@/components/table"
import TypeForm from "@/components/TypeForm.vue"

const props = defineProps({
	types: {
		type: Array,
		default: () => []
	},
	parentId: {
		type: [String, Number],
		default: ""
	},
	pending: Boolean
})
const emit = defineEmits([ "update", "startPending" ])

const ts = useTypesStore()
const toast = useToast()

const columns = [
	{
		label: "Название",
		field: "name"
	},
	{
		label: "Ссылка",
		field: "slug"
	},
	{
		label: "Кол-во товаров",
		field: "Products"
	},
	{
		field: "buttons"
	}
]

const modal = ref(false)
const editModal = ref(false)
const onRemove = ref(null)
const onEdit = ref(null)

watch(onRemove, nv => modal.value = !!nv)
watch(modal, nv => {
	if (!nv) onRemove.value = null
})

watch(onEdit, nv => editModal.value = !!nv)
watch(editModal, nv => {
	if (!nv) onEdit.value = null
})

const handleUpdate = name => {
	emit("update")
	editModal.value = false
	toast.success(`Успешно изменили "${name}"`)
}

const remove = async id => {
	onRemove.value = null

	emit("startPending")
	await ts.remove(id)
	emit("update")
}
</script>